-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib
local t,s
lib.classes["HUNTER"] = {}
lib.classes["HUNTER"][4] = function ()

	cfg.spells={}
	lib.AddSpell("melee",{6603}) -- Melee
	lib.AddSpell("AS",{3044}) -- Arcane Shot
	lib.AddSpell("ss",{56641}) -- Steady Shot	
				
	cfg.auras={}
	
	local plist = {}
	table.insert(plist,"AS")
	table.insert(plist,"ss")
	table.insert(plist,"end")

	cfg.plist=plist

	cfg.case = {}

	return true
end

lib.classes["HUNTER"][3] = function ()

	cfg.spells={}
	lib.AddSpell("melee",{6603}) -- Melee
	lib.AddSpell("AS",{3044}) -- Arcane Shot
	lib.AddSpell("ss",{56641}) -- Steady Shot	
	lib.AddSpell("es",{53301}) -- Explosive Shot
	lib.AddSpell("sting",{1978}) -- Serpent Sting
	lib.AddSpell("mark",{1130}) -- Hunter's Mark
	lib.AddSpell("ks",{53351}) -- Kill Shot
	lib.AddSpell("kc",{34026}) -- Kill Command
	lib.AddSpell("ms",{2643}) -- Multi-Shot
	lib.AddSpell("trap",{77769}) -- Trap Launcher
	lib.AddSpell("et",{13813}) -- Explosive Trap
	lib.AddSpell("ba",{3674}) -- Black Arrow
	
	cfg.auras={}
	lib.AddAura("es",53301,"debuff","target") -- Explosive Shot
	lib.AddAura("lnl",56453,"buff","player") -- Lock and Load
	lib.AddAura("Sting",1978,"debuff","target") -- Serpent Sting
	lib.AddAura("Mark",1130,"debuff","target","any") -- Hunter's Mark
		
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"ks")
	table.insert(cfg.plistdps,"es_lnl")
--	table.insert(cfg.plistdps,"mark")
	table.insert(cfg.plistdps,"sting")
	table.insert(cfg.plistdps,"ba")
	table.insert(cfg.plistdps,"es")
	table.insert(cfg.plistdps,"kc_es")
	table.insert(cfg.plistdps,"as_es")
	table.insert(cfg.plistdps,"trap")
	table.insert(cfg.plistdps,"AS")
	table.insert(cfg.plistdps,"ss")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"ks")
	table.insert(cfg.plistaoe,"es_lnl")
	table.insert(cfg.plistaoe,"trap")
	table.insert(cfg.plistaoe,"ms")
	table.insert(cfg.plistaoe,"ss")
	table.insert(cfg.plistaoe,"end")

	cfg.plist = cfg.plistdps

	cfg.case = {}
	cfg.case = {
		["trap"] = function()
			if cfg.spells["trap"] and cfg.power>=cfg.spells["trap"].powerCost then
				return lib.SimpleCDCheck("et")
			end
			return nil
		end,
		["mark"] = function()
			local t = lib.GetAura({"Mark"})
			if t<3 then
				return lib.SimpleCDCheck("mark")
			end
			return nil
		end,
		["sting"] = function()
			local t = lib.GetAura({"Sting"})
			if t<3 then
				return lib.SimpleCDCheck("sting")
			end
			return nil
		end,
		["es"] = function()
			if lib.GetAura({"es"})<1 then
				return lib.SimpleCDCheck("es")
			end
			return nil
		end,
		["es_lnl"] = function()
			if lib.GetAura({"lnl"})>0 and lib.GetAura({"es"})<1 then
				return lib.SimpleCDCheck("es")
			end
			return nil
		end,
		["kc_es"] = function()
			if lib.GetAura({"es"})>0 and lib.GetAura({"lnl"})>0 then
				return lib.SimpleCDCheck("kc")
			end
			return nil
		end,
		["as_es"] = function()
			if lib.GetAura({"es"})>0 and lib.GetAura({"Sting"})>6 and lib.GetAura({"lnl"})==0 then
				return lib.SimpleCDCheck("AS")
			end
			return nil
		end,
		["AS"] = function()
			if cfg.power > 70 then
				lib.SimpleCDCheck("AS")
			end
			return nil
		end,
	}

	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		print(cfg.mode)
	end
	
	return true
end

lib.classes["HUNTER"][2] = function ()

	lib.AddSpell("AS",{3044}) -- Arcane Shot
	lib.AddSpell("SS",{56641}) -- Steady Shot	
	cfg.spells["SS"].powerCost=-9
	lib.AddSpell("SrS",{1978}) -- Serpent Sting
	lib.AddSpell("mark",{1130}) -- Hunter's Mark
	lib.AddSpell("CS",{53209}) -- Chimera Shot
	lib.AddSpell("AI",{19434}) -- Aimed Shot
--	lib.AddSpell("AI!",{82928}) -- Aimed Shot!
	
	lib.AddSpell("KS",{53351}) -- Kill Shot
	lib.AddSpell("KC",{34026}) -- Kill Command
	
	lib.AddSpell("MS",{2643}) -- Multi-Shot
	
	lib.AddSpell("trap",{77769}) -- Trap Launcher
	lib.AddSpell("ET",{13813}) -- Explosive Trap
	lib.AddSpell("RF",{3045}) -- Rapid Fire
	lib.AddSpell("Rs",{23989}) -- Readiness
	
	lib.AddAura("MMM",82925,"buff","player") -- Ready, Set, Aim...
	lib.AddAura("Fire",82926,"buff","player") -- Fire!
	lib.AddAura("ISS",53220,"buff","player") -- Improved Steady Shot
	lib.AddAura("RiF",82897,"buff","player") -- Resistance is Futile!
	lib.AddAura("SrS",1978,"debuff","target") -- Serpent Sting
	lib.AddAura("Mark1",1130,"debuff","target","any") -- Hunter's Mark
	lib.AddAura("Mark2",88691,"debuff","target","any") -- Marked for Death
	lib.AddAura("Speed1",3045,"buff","player") -- Rapid Fire
	lib.AddAura("Speed2",32182,"buff","player","any") -- Heroism
	lib.AddAura("Speed3",80353,"buff","player","any") -- Time Warp
	lib.AddAura("Speed4",90355,"buff","player","any") -- Ancient Hysteria
	lib.AddAura("Speed5",49016,"buff","player","any") -- Hysteria, Unholy Frenzy
	lib.AddAura("Speed6",92124,"buff","player") -- Nefarious Plot 359
	lib.AddAura("Speed7",92349,"buff","player") -- Nefarious Plot 372
		
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"mark")
	table.insert(cfg.plistdps,"SrS_noSrS")
	table.insert(cfg.plistdps,"KS")
--	table.insert(cfg.plistdps,"CS_SrS")
	table.insert(cfg.plistdps,"AI_Fire")
	table.insert(cfg.plistdps,"RF")
	table.insert(cfg.plistdps,"Rs")
	table.insert(cfg.plistdps,"CS")
	table.insert(cfg.plistdps,"AI_90")
	table.insert(cfg.plistdps,"SS_noISS")
	table.insert(cfg.plistdps,"as_focus")
	table.insert(cfg.plistdps,"KC_RiF")
	table.insert(cfg.plistdps,"SS")
		
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"KS")
	table.insert(cfg.plistaoe,"trap")
	table.insert(cfg.plistaoe,"MS")
	table.insert(cfg.plistaoe,"AI_Fire")
	table.insert(cfg.plistaoe,"SS")

	cfg.plist = cfg.plistdps

	cfg.case = {}
	cfg.case = {
		["CS"] = function()
			t,s = lib.SpellCasting()
			if t and cfg.spells[s] then
				if cfg.power>=(cfg.spells["CS"].powerCost+cfg.spells[s].powerCost) then
					return lib.SimpleCDCheck("CS")
				end
			else
				return lib.SimpleCDCheck("CS")
			end
		end,
		["RF"] = function()
			if cfg.power<=cfg.spells["AI"].powerCost and lib.GetAuras("Speed")==0 then
				return lib.SimpleCDCheck("RF")
			end
			return nil
		end,
		["Rs"] = function()
			if lib.SpellTL("RF")>3 then
				return lib.SimpleCDCheck("Rs")
			end
			return nil
		end,
		["as_focus"] = function()
			if cfg.health<90 and cfg.power>=(cfg.spells["CS"].powerCost+cfg.spells["AS"].powerCost) then
				return lib.SimpleCDCheck("AS")
			end
			return nil
		end,
		["KC_RiF"] = function()
			if lib.GetAura({"RiF"})>0 then
				return lib.SimpleCDCheck("KC")
			end
			return nil
		end,
		["mark"] = function()
			if lib.GetAuras("Mark")==0 then
				return lib.SimpleCDCheck("mark")
			end
			return nil
		end,
		["SrS_noSrS"] = function()
			if lib.GetAura({"SrS"})==0 then
				return lib.SimpleCDCheck("SrS")
			end
			return nil
		end,
		["AI_90"] = function()
--[[			if cfg.health>=80 and lib.GetAura({"ISS"})>0 and not lib.SpellCasting("AI") then
				return lib.SimpleCDCheck("AI")
			end]]
			if cfg.health>=90 and lib.GetAura({"ISS"})>0 then
				t,s = lib.SpellCasting()
				if t then
					if cfg.power>=(cfg.spells["AI"].powerCost+cfg.spells[s].powerCost) then
						return lib.SimpleCDCheck("AI")
					end
				else
					return lib.SimpleCDCheck("AI")
				end
			end
			return nil
		end,
		["CS_SrS"] = function()
			if lib.GetAura({"SrS"})<5 then
				return lib.SimpleCDCheck("CS")
			end
			return nil
		end,
		["AI_Fire"] = function()
			if lib.GetAura({"Fire"})>0 then
				return lib.SimpleCDCheck("AI",true,true)
			end
			return nil
		end,
		["SS_noISS"] = function()
			t = lib.GetAura({"ISS"})
			if cfg.lastspell==cfg.spells["SS"].name and not lib.SpellCasting("SS") then
				return lib.SimpleCDCheck("SS")
			end

			if lib.GetAura({"ISS"})==0 then
				return lib.SimpleCDCheck("SS")
			end
			return nil
		end,
		["trap"] = function()
			if cfg.spells["trap"] and cfg.power>=cfg.spells["trap"].powerCost then
				return lib.SimpleCDCheck("ET")
			end
			return nil
		end,
	}

	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		print(cfg.mode)
	end
	
	cfg.spellcaster=true
	return true
end

lib.classevents["HUNTER"] = function()
	lib.rangecheck=function()
		if lib.inrange("AS") then
			lib.bdcolor(Heddframe.bd,nil)
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	lib.myonhealthupdate = function()
		if lib.UpdateSpellCD("ks") then cfg.Update=true end
	end
	
	cfg.onpower=true
end